--- tn3270/ctlr/api.h	Mon Feb  6 19:07:56 1989
***************
*** 14,20 ****
   * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
   *
!  *	%W% (Berkeley) %G%
   */
  
  /*
--- 14,20 ----
   * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
   *
!  *	@(#)api.h	4.2 (Berkeley) 2/6/89
   */
  
  /*
***************
*** 319,327 ****
   * into which of the "words".
   */
  
  struct highlow {
      unsigned char
! #if	defined(vax) || defined(ns32000)
  	al,
  	ah,
  	bl,
--- 319,345 ----
   * into which of the "words".
   */
  
+ #include <sys/param.h>		/* Get ENDIAN from machine/endian.h */
+ 
+ /* Determine endian'ess (if necessary) */
+ 
+ #if	!(defined(BYTE_ORDER) && defined(BIG_ENDIAN))
+ #define	LITTLE_ENDIAN	1234	/* least-significant byte first (vax) */
+ #define	BIG_ENDIAN	4321	/* most-significant byte first (IBM, net) */
+ 
+ #if	defined(vax) || defined(ns32000)
+ #define	BYTE_ORDER	LITTLE_ENDIAN
+ #endif	/* defined(vax) || defined(ns32000) */ 
+ 
+ #if	defined(sun) || defined(tahoe) || defined(ibm032) || defined(pyr) || defined(gould)
+ #define	BYTE_ORDER	BIG_ENDIAN
+ #endif	/* defined(sun) || defined(tahoe) || defined(ibm032) || defined(pyr) || defined(gould) */
+ 
+ #endif	/* !(defined(BYTE_ORDER) && defined(BIG_ENDIAN)) */
+ 
  struct highlow {
      unsigned char
! #if	BYTE_ORDER == LITTLE_ENDIAN
  	al,
  	ah,
  	bl,
***************
*** 330,337 ****
  	ch,
  	dl,
  	dh;
! #endif	/* defined(vax) || defined(ns32000) */ 
! #if	defined(sun) || defined(tahoe) || defined(ibm032) || defined(pyr)
  	ah,
  	al,
  	bh,
--- 348,355 ----
  	ch,
  	dl,
  	dh;
! #endif	/* BYTE_ORDER == LITTLE_ENDIAN */
! #if	BYTE_ORDER == BIG_ENDIAN
  	ah,
  	al,
  	bh,
***************
*** 340,346 ****
  	cl,
  	dh,
  	dl;
! #endif	/* defined(sun) || defined(tahoe) || defined(ibm032) || defined(pyr) */
  };
  
  struct words {
--- 358,364 ----
  	cl,
  	dh,
  	dl;
! #endif	/* BYTE_ORDER == BIG_ENDIAN */
  };
  
  struct words {
